/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.fel.pjv.cv11.threadpool;

import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author martin
 */
public class MainThreadPool_call {
    
    public static void main(String[] args) {
        //kolik chci mit uloh pro spusni v threadpoolu - postupne
        int numTasks=10;
        
        ExecutorService threadPool;
        
        //chci pustit naraz max 3 vlakna
        threadPool=Executors.newFixedThreadPool(3);
        
        //poustim jen jedno vlakno naraz
        //threadPool=Executors.newSingleThreadExecutor();
        
        Callable<String> task[] = new Callable[numTasks];
        for (int i = 0; i < numTasks; i++) {
            task[i]=new MyCallable(10,i);            
        }
        
        Future futureResults[] = new Future[numTasks];
        //odesli vsechny ulohy ke zpracovani do TP
        for (int i = 0; i < numTasks; i++) {
            futureResults[i]=threadPool.submit(task[i]);            
        }
        
        //neblokujici volani
        for (Future futureResult : futureResults) {
            System.out.println("MAIN VLAKNO: "+futureResult.isDone());
        }
        
        //blokujici volani - get() vraci null poku dvlakno dobehlo
        for (Future futureResult : futureResults) {
            try {                
                System.out.println("MAIN VLAKNO: FUTURE.GET "+futureResult.get());
            } catch (InterruptedException ex) {
                Logger.getLogger(MainThreadPool_call.class.getName()).log(Level.SEVERE, null, ex);
            } catch (ExecutionException ex) {
                Logger.getLogger(MainThreadPool_call.class.getName()).log(Level.SEVERE, null, ex);
            }
            
        }
        
        //nezapomenout slikvidovat threadpool
        threadPool.shutdown();
        System.out.println("MAIN KONEC");
        
    }
    
}
